#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Flashlight.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 7 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Flashlight.fx"
#line 21
uniform float uBrightness <
ui_label = "Brightness";
ui_tooltip =
"Flashlight halo brightness.\n"
"\nDefault: 10.0";
ui_type = "drag";
ui_min = 0.0;
ui_max = 100.0;
ui_step = 0.01;
> = 10.0;
#line 32
uniform float uSize <
ui_label = "Size";
ui_tooltip =
"Flashlight halo size in pixels.\n"
"\nDefault: 420.0";
ui_type = "drag";
ui_min = 10.0;
ui_max = 1000.0;
ui_step = 1.0;
> = 420.0;
#line 43
uniform float3 uColor <
ui_label = "Color";
ui_tooltip =
"Flashlight halo color.\n"
"\nDefault: R:255 G:230 B:200";
ui_type = "color";
> = float3(255, 230, 200) / 255.0;
#line 52
uniform float uDistance <
ui_label = "Distance";
ui_tooltip =
"The distance that the flashlight can illuminate.\n"
"Only works if the game has depth buffer access.\n"
"\nDefault: 0.1";
ui_type = "drag";
ui_min = 0.0;
ui_max = 1.0;
ui_step = 0.001;
> = 0.1;
#line 65
sampler2D sColor {
Texture = ReShade::BackBufferTex;
SRGBTexture = true;
MinFilter = POINT;
MagFilter = POINT;
};
#line 74
float4 PS_Flashlight(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET {
float2 res = ReShade::ScreenSize;
float2 coord = uv * res;
#line 78
float halo = distance(coord, res * 0.5);
float flashlight = uSize - min(halo, uSize);
flashlight /= uSize;
#line 85
float defects = sin(flashlight * 30.0) * 0.5 + 0.5;
defects = lerp(defects, 1.0, flashlight * 2.0);
#line 88
static const float contrast = 0.125;
#line 90
defects = 0.5 * (1.0 - contrast) + defects * contrast;
flashlight *= defects * 4.0;
#line 97
float depth = 1.0 - ReShade::GetLinearizedDepth(uv);
depth = pow(abs(depth), 1.0 / uDistance);
flashlight *= depth;
#line 102
float3 colored_flashlight = flashlight * uColor;
colored_flashlight *= colored_flashlight * colored_flashlight;
#line 105
float3 result = 1.0 + colored_flashlight * uBrightness;
#line 107
float3 color = tex2D(sColor, uv).rgb;
color *= result;
#line 113
color = max(color, (result - 1.0) * 0.001);
#line 117
return float4(color, 1.0);
}
#line 120
technique Flashlight {
pass {
VertexShader = PostProcessVS;
PixelShader = PS_Flashlight;
SRGBWriteEnable = true;
}
}

